﻿using System;
using System.IO.Ports;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace CSharp_DHHalLib_Wrapper_App
{
    class CANTest
    {
        public static void Testcode()
        {
            CAN_OurCode();
        }

        private static void DataReceivedHandler(object sender)
        {
            Console.WriteLine("Data Received:");
        }

        private static void CAN_OurCode()
        {
            byte[] buffer = new byte[8];
            buffer = Encoding.ASCII.GetBytes("01234567");
            string result;
            int resultcode = 0;

            //Open CAN Port
            DHHalLib.CANOpen(DHCOM_CANEnum.DHCOM_CAN1, DHCOM_CANModeEnum.DHCOM_CAN_STANDARD);

            //Configure CAN Port
            DHHalLib.CANConfigureMode(DHCOM_CANEnum.DHCOM_CAN1, DHCOM_CANModeEnum.DHCOM_CAN_STANDARD, 500000);

            //Configure CAN Input Message
            DHHalLib.CANConfigureMessage(DHCOM_CANEnum.DHCOM_CAN1, DHCOM_CANFrameEnum.DHCOM_CAN_DATA, 0, 0, 0xfa0, false);

            //Configure CAN Output Message
            DHHalLib.CANConfigureMessage(DHCOM_CANEnum.DHCOM_CAN1, DHCOM_CANFrameEnum.DHCOM_CAN_DATA, 0, 0, 0xfa0, true);

            //Configure CAN Filter
            DHHalLib.CANConfigureFilter(DHCOM_CANEnum.DHCOM_CAN1, 0, 0, false, false);

            //Write CAN Data
            DHHalLib.CANWrite(DHCOM_CANEnum.DHCOM_CAN1, buffer, 8, ref resultcode);

            //Read CAN Data
            DHHalLib.CANRead(DHCOM_CANEnum.DHCOM_CAN1, buffer, 8, ref resultcode);

            result = BitConverter.ToString(buffer, 0, 8);
            //result = System.Text.Encoding.UTF8.GetString(buffer, 0, buffer.Length);
            Console.WriteLine("CAN Return Data: {0}", result);
            Console.WriteLine("CAN Result Code: {0}", resultcode);

            //Close CAN Port
            DHHalLib.CANClose(DHCOM_CANEnum.DHCOM_CAN1);
        }
    }
}
