﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading;


namespace CSharp_DHHalLib_Wrapper_App
{
    class GPIOTest1
    {
        #region P/Invoke declarations for SafeWaitHandle

        [DllImport("coredll.dll", EntryPoint = "OpenEventW", CharSet = CharSet.Auto)]
        static extern IntPtr OpenEvent(uint dwDesiredAccess, bool bInheritHandle, string lpName);

        [DllImport("coredll.dll", EntryPoint = "CreateEventW", CharSet = CharSet.Auto)]
        static extern IntPtr CreateEvent(IntPtr lpEventAttributes, bool bManualReset, bool bInitialState, string lpName);

        #endregion

        #region Defines
        static AutoResetEvent arEvent = new AutoResetEvent(false);
        static bool bBreak = false;

        #endregion

        public static void InterruptThread()
        {
            uint unEventPermissions = 2031619;

            IntPtr hEvent = IntPtr.Zero;
            
            hEvent = CreateEvent(hEvent, false, false, "");

            if (IntPtr.Zero == hEvent)
            {
                Console.WriteLine("OpenEvent failed");
                return; // Exit 
            }

            arEvent.Handle = hEvent;

            WaitHandle[] waitHandles;
            waitHandles = new WaitHandle[1];
            //Put it in our array for WaitAny()
            waitHandles[0] = arEvent;

            //Set Single Interrupt
            DHHalLib.GPIOSetInterrupt(DHCOM_GPIOEnum.DHCOM_GPIO_A, DHCOM_GPIOISRType.DHCOM_GPIO_INTR_BOTH_EDGE, arEvent.SafeWaitHandle);

            while (bBreak != true)
            {
                int waitResult = WaitHandle.WaitAny(waitHandles, 0);

                if (waitResult == WaitHandle.WaitTimeout)
                {
                    Console.WriteLine(" WaitAny timed out.");

                    //Disable LED
                    DHHalLib.GPIOSetPin(DHCOM_GPIOEnum.DHCOM_GPIO_E, false);
                }
                else if (0 == waitResult)
                {
                    Console.WriteLine("0 == waitResult. Yippee !!!");

                    //Enable LED
                    DHHalLib.GPIOSetPin(DHCOM_GPIOEnum.DHCOM_GPIO_E, true);
                }
                else if (1 == waitResult)
                {
                    Console.WriteLine("1 == waitResult !!!");
                    // Do Something Else
                }
                else
                {
                    Console.WriteLine("Error else");
                }

                System.Threading.Thread.Sleep(100);
            }

            //Enable LED
            DHHalLib.GPIOSetPin(DHCOM_GPIOEnum.DHCOM_GPIO_E, true);

            //Clear GPIO Interrupt
            DHHalLib.GPIOClearInterrupt(DHCOM_GPIOEnum.DHCOM_GPIO_A);
        }

        public static void Testcode()
        {
            GPIO_StartInterruptThread();
        }

        private static void GPIO_StartInterruptThread()
        {
            //Call in thread
            System.Threading.Thread oInterruptThread = new System.Threading.Thread(InterruptThread);

            //Set Direction
            DHHalLib.GPIOSetDirection(DHCOM_GPIOEnum.DHCOM_GPIO_A, true, false);

            //Start Interrupt Thread
            oInterruptThread.Start();

            Console.WriteLine("Press Enter to stop Test");

            while (!(Console.ReadLine() == ""))
            {
                // do something
            }

            Console.WriteLine("GPIO Interrupt Test stopped!");

            bBreak = true;
        }
    }
}
