﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CSharp_DHHalLib_Wrapper_App
{
    class I2CTest
    {
        public static void Testcode()
        {
            I2C_WriteRead();
            I2C_WriteRead_Multiple();
        }

        private static void I2C_WriteRead()
        {
            byte[] outBuffer = new byte[1];
            byte devID = 0x50;
            byte regADDR = 0x10;
            byte regVAL = 0x10;

            Console.WriteLine("I2C Write REG: " + devID + " ADDR: " + regADDR + " VAL: " + regVAL);

            DHHalLib.I2CWrite(DHCOM_I2CEnum.DHCOM_I2C0, DHCOM_I2CFREQMode.I2C_400K, devID, regADDR, regVAL);

            DHHalLib.I2CRead(DHCOM_I2CEnum.DHCOM_I2C0, DHCOM_I2CFREQMode.I2C_400K, devID, regADDR, outBuffer);

            Console.WriteLine("I2C Read REG: " + devID + " ADDR: " + regADDR + " VAL: " + outBuffer[0]);

            Console.WriteLine("----------------------------------");

            //Check Return Value

            if (regVAL == outBuffer[0])
            {
                Console.WriteLine("I2C Write/Read Test passed");
            }
            else
            {
                Console.WriteLine("I2C Write/Read Test failed");
            }

            Console.WriteLine("----------------------------------");
        }

        private static void I2C_WriteRead_Multiple()
        {
            byte[] writeBuffer = new byte[4];
            byte[] readBuffer = new byte[4];
            byte devID = 0x50;
            byte regADDR = 0x10;
            byte regLEN = 4;
            int count = 0;

            writeBuffer[0] = 0x1;
            writeBuffer[1] = 0x2;
            writeBuffer[2] = 0x3;
            writeBuffer[3] = 0x4;

            Console.WriteLine("I2C Write REG: " + devID + " ADDR: " + regADDR);

            foreach (var b in writeBuffer)
            {
                Console.WriteLine(" VAL " + count + ": " + writeBuffer[count]);
                count = count + 1;
            }

            DHHalLib.I2CWriteMultipleBytes(DHCOM_I2CEnum.DHCOM_I2C0, DHCOM_I2CFREQMode.I2C_400K, devID, regADDR, regLEN, writeBuffer);

            DHHalLib.I2CReadMultipleBytes(DHCOM_I2CEnum.DHCOM_I2C0, DHCOM_I2CFREQMode.I2C_400K, devID, regADDR, regLEN, readBuffer);

            Console.WriteLine("I2C Read REG: " + devID + " ADDR: " + regADDR);

            count = 0;

            foreach (var b in readBuffer)
            {
                Console.WriteLine(" VAL " + count + ": " + readBuffer[count]);
                count = count + 1;
            }

            Console.WriteLine("----------------------------------");

            //Check Return Value

            if (Convert.ToString(writeBuffer) == Convert.ToString(readBuffer))
            {
                Console.WriteLine("I2C Write/Read Multiple Test passed");
            }
            else
            {
                Console.WriteLine("I2C Write/Read Multiple Test failed");
            }

            Console.WriteLine("----------------------------------");
        }
    }
}
